<div class="row">
    <div class="col-6 card card-block p-4" id="preview-left">
        <div class="row">
            <h5 class="card-title">Inital answer (to build upon, can be empty)</h5>
        </div>
        <div class="row card card-body">
            <textarea
              id="initial_diagram_answer"
              name="initial_diagram_answer"
              style="min-height: 300px;"><%-diagram_question_answer.initial_diagram_answer%></textarea>
        </div>
    </div>
    <div class="col-6 card card-block p-4" id="preview-right">
        <div class="row">
            <h5 class="card-title">Preview:</h5>
        </div>
        <div class="row card card-body">
          <div class="col-12" id="initial_diagram_answer_preview"></div>
        </div>
    </div>
</div>

<div class="row">
  <div class="col-6 card card-block p-4" id="preview-left">
    <div class="row">
      <h5 class="card-title">Answer</h5>
    </div>
    <div class="row card card-body">
      <textarea
        id="diagram_answer"
        name="diagram_answer"
        style="min-height: 300px;"><%-diagram_question_answer.diagram_answer%></textarea>
    </div>
  </div>
  <div class="col-6 card card-block p-4" id="preview-right">
    <div class="row">
        <h5 class="card-title">Answer preview:</h5>
    </div>
    <div class="row card card-body">
      <div
        class="col-12"
        style="min-height: 300px;"
        id="diagram_answer_preview"></div>
    </div>
  </div>
</div>


<script>
  window.onload = function() {
    var textAreaElement = document.querySelector("#initial_diagram_answer");
    // var textAreaElementMirror = document.querySelector("#initial_diagram_answer_preview");

    var corrAnsTextAreaElement = document.querySelector("#diagram_answer");
    // var corrAnsTextAreaElementMirror = document.querySelector("#diagram_answer_preview");

    if (textAreaElement) {
      textAreaElement.addEventListener("input", function() {
          renderGraph(textAreaElement, "#initial_diagram_answer_preview");
      });
    }

    if (corrAnsTextAreaElement) {
      corrAnsTextAreaElement.addEventListener("input", function() {
        renderGraph(corrAnsTextAreaElement, "#diagram_answer_preview");
      });
    }

    // Render the initial graphs
    renderGraph(textAreaElement, "#initial_diagram_answer_preview");
    renderGraph(corrAnsTextAreaElement, "#diagram_answer_preview");
  }

  var element = document.createElement("div");
  element.className += " mermaid-graph";

  function decodeEntities(str) {
    if (str && typeof str === "string") {
      str = str.replace(/<script[^>]*>([\S\s]*?)<\/script>/gim, "");
      str = str.replace(/<\/?\w(?:[^"'>]|"[^"]*"|'[^']*')*>/gim, "");
      element.innerHTML = str;
      str = element.textContent;
      element.textContent = "";
    }

    return str;
  }

  var insertSvg = function(svgCode, graphDefinitionElement) {
    var graph = document.createElement("div");
    graph.className += ' ' + new Date().getTime();
    graph.setAttribute("id", "graph-div");
    graph.innerHTML = svgCode;
    graphDefinitionElement.appendChild(graph);
  };


  async function renderGraph(textAreaElement, graphId) {
    var graphDefinition = decodeEntities(textAreaElement.value);
    var graphDefinitionElement = document.querySelector(graphId);

    try {
      graphDefinitionElement.innerHTML = "";
    } catch (e) {
      console.log("no existing graph found");
    }

    if (mermaid.parse(graphDefinition)) {
      var diagramId = "graph-diagram-" + graphId.slice(1);
      const { svg } = await mermaid.render(diagramId, graphDefinition);
      insertSvg(svg, graphDefinitionElement);
    }
  }

</script>

